Index: trunk/kernel/kern/process.h
===================================================================
--- trunk/kernel/kern/process.h	(revision 690)
+++ trunk/kernel/kern/process.h	(revision 1)
@@ -227,180 +185,76 @@
 
 /*********************************************************************************************
- * This function initialize, in each cluster, the kernel "process_zero", that contains
- * all kernel threads in a given cluster. It is called by the kernel_init() function.
- * The process_zero descriptor is allocated as a global variable in file kernel_init.c 
- * Both the PID and PPID fields are set to zero, the ref_xp is the local process_zero,
- * and the parent process is set to XPTR_NULL. The th_tbl[] is initialized as empty.
- * The process GPT is initialised as required by the target architecture.
- * The "kcode" and "kdata" segments are registered in the process VSL.
- * This function does not return an error code: in case of failure, it print a PANIC message
- * on kernel terminal TXT0, and the core goes to sleep mode.
- *********************************************************************************************
- * @ process  : [in] pointer on process descriptor to initialize.
- * @ info     : pointer on local boot_info_t (for kernel segments base and size). 
- ********************************************************************************************/
-void process_zero_create( process_t   * process,
-                          boot_info_t * info );
-
-/*********************************************************************************************
- * This function allocates memory and initializes the "process_init" descriptor and the
- * associated "thread_init" descriptor. It is called once at the end of the kernel_init() 
- * procedure. Its local process identifier is 1, and parent process is the kernel process.
- * The "process_init" is the first user process, and all other user processes will be forked
- * from this process. The code executed by "process_init" is stored in a .elf file, whose
- * pathname is defined by the CONFIG_PROCESS_INIT_PATH configuration variable. 
- * This function does not return an error code: in case of failure, it print a PANIC message
- * on kernel terminal TXT0, and the core goes to sleep mode.
- ********************************************************************************************/
-void process_init_create( void );
-
-/*********************************************************************************************
- * This function initializes a reference user process descriptor from another process
- * descriptor, defined by the <parent_xp> argument. The <process> and <pid> arguments 
- * are previously allocated by the caller. This function can be called by two functions:
- * -  process_init_create() : process is the INIT process, and parent is process-zero.
- * -  process_make_fork()   : the parent process descriptor is generally remote.
- * The following fields are initialised :
- * - It set the pid / ppid / ref_xp / parent_xp / state fields.
- * - It creates an empty GPT and an empty VSL.
- * - It initializes the locks protecting the GPT and the VSL.
- * - It registers the "kernel" vsegs in VSL, using the hal_vmm_kernel_update() function.
- * - It registers the "args" and "envs" vsegs in VSL, using the vmm_user_init() function.
- * - The "code and "data" must be registered later, using the elf_load_process() function.
- * - It initializes the FDT, defining the three pseudo files STDIN / STDOUT / STDERR.
- *   . if INIT process     => link to kernel TXT[0].
- *   . if KSH[i] process   => allocate a free TXT[i].
- *   . if USER process     => link to parent process TXT[i].
- * - It set the root_xp, bin_xp, cwd_xp fields.
- * - It reset the children list as empty, but does NOT register it in parent children list.
- * - It reset the TH_TBL list of threads as empty.
- * - It reset the semaphore / mutex / barrier / condvar lists as empty.
- * - It registers the process in the local_list, rooted in the local cluster manager.
- * - It registers the process in the copies_list, rooted in the owner cluster manager.
- * - It registers the process extended pointer in the local pref_tbl[] array.
- *********************************************************************************************
- * @ process      : [in] pointer on local process descriptor to initialize.
- * @ pid          : [in] process identifier.
- * @ parent_xp    : [in] extended pointer on parent process descriptor.
- * @ return 0 if success / return -1 if failure
- ********************************************************************************************/
-error_t process_reference_init( process_t * process,
-                                pid_t       pid,
-                                xptr_t      parent_xp );
-
-/*********************************************************************************************
- * This function initializes a copy process descriptor, in the local cluster,
- * from information defined in the reference remote process descriptor.
- * As the VSL and the GPT of a process copy are handled as local caches, the GPT copy is 
- * created empty, and the VSL copy contains only the "kernel", "args", and "envs" vsegs. 
- *********************************************************************************************
+ * This function initializes the kernel process_zero descriptor (global variable) from
+ * informations found in the boot_info.
+ ********************************************************************************************* 
+ * @ info      : pointer on local boot_info_t structure.
+ ********************************************************************************************/
+void process_zero_init( boot_info_t * info );
+
+/********************************************************************************************* 
+ * This function allocates memory and initialises the "process_init" descriptor and the
+ * associated thread descriptor from information found in the "process_zero" descriptor.
+ ********************************************************************************************* 
+ * Any error gives a kernel panic.
+ ********************************************************************************************/
+void process_init_create();
+
+/********************************************************************************************* 
+ * This function intializes a new process descriptor, in the reference cluster.
+ * The PID value must have been defined previously by the owner cluster manager.
+ * The reference cluster can be different from the owner cluster. 
+ * It set the pid / ppid / is_ref / pref / fields.
+ * It registers this process descriptor in three lists:
+ * - the children_list in the parent process descriptor.
+ * - the local_list, rooted in the reference cluster manager.
+ * - the copies_list, rooted in the owner cluster manager.
+ * It reset the embedded structures such as the VMM or the file descriptor array.
+ ********************************************************************************************* 
+ * @ process      : [in] pointer on process descriptor to initialize.
+ * @ pid          : [in] process identifier defined by owner cluster.
+ * @ ppid         : [in] parent process identifier.
+ ********************************************************************************************/
+void process_reference_init( process_t * process,
+                             pid_t       pid,
+                             pid_t       ppid );
+
+/********************************************************************************************* 
+ * This function intializes a copy process descriptor, in the local cluster,
+ * from informations defined in the reference remote process descriptor.
+ ********************************************************************************************* 
  * @ process              : [in] local pointer on process descriptor to initialize.
  * @ reference_process_xp : [in] extended pointer on reference process descriptor.
- * @ return 0 if success / return -1 if failure
+ * @ return 0 if success / return ENOMEM if failure
  ********************************************************************************************/
 error_t process_copy_init( process_t * local_process,
                            xptr_t      reference_process_xp );
 
-/*********************************************************************************************
+/********************************************************************************************* 
  * This function releases all memory allocated for a process descriptor in the local cluster,
- * including memory allocated for embedded sub-structures (fd_array, vmm, etc).
+ * after releasing memory allocated for embedded substructures (fd_array, vmm, etc).
  * The local th_tbl[] array must be empty.
- *********************************************************************************************
- * @ process     : [in] pointer on the process descriptor.
+ ********************************************************************************************* 
+ * @ process     : pointer on the process descriptor.
  ********************************************************************************************/
 void process_destroy( process_t * process );
 
-/*********************************************************************************************
- * This debug function diplays on the kernel terminal TXT0 detailed informations on a 
- * process descriptor identified by the <process_xp> argument.
- * It can be called by a thread running in any cluster.
- * WARNING: this function uses the nolock_printk() function, and the  TXT0 lock MUST be
- * taken by the caller function. 
- *********************************************************************************************
- * @ process_xp    : [in] extended pointer on process descriptor.
- ********************************************************************************************/
-void process_display( xptr_t process_xp );
-
-/*********************************************************************************************
- * This function returns a printable string defining the sigaction type.
- *********************************************************************************************
- * @ sigaction_type   : BLOCK_ALL_THREADS / UNBLOCK_ALL_THREADS / DELETE_ALL_THREADS
- * @ return a string pointer.
- ********************************************************************************************/
-const char * process_action_str( process_sigactions_t sigaction_type );
-
-/*********************************************************************************************
- * This function allows a client thread running in any cluster to block, unblock or delete 
- * all threads of a process identified by the <pid> argument, depending on the 
- * <action_type> argument.
- *
- * It uses the multicast, non blocking rpc_process_sigaction_client() function to send
- * parallel requests to all remote clusters containing process copies. 
- * Then it blocks and deschedule to wait completion of these parallel requests.
- *
- * It is used by the sys_kill() & sys_exit() functions to handle the "kill" & "exit" syscalls.
- * It is also used by the process_make_exec() function to handle the "exec" syscall.
- * It is also called by the TXT device ISR to execute the ctrl C & ctrl Z commands.
- *
- * WARNING (1) the DELETE action is NOT executed on the target process main thread
- * (thread 0 in process owner cluster), and not executed on the client thread itself.
- *
- * WARNING (2) the BLOCK action is executed on all target process threads, and this function
- * returns only when all threads BUT the client thread are actually blocked and not running.
- * When the client thread is also a target thread, it is blocked but not descheduled. 
- * 
- * WARNING (3) the UNBLOCK action is executed on all target process threads, as the
- * client thread cannot be a target thread.
- *
- * Implementation note:
- * This function allocates a - shared - RPC descriptor in client thread stack, 
- * and initializes it. This RPC descriptor can be shared because all parallel,
- * non-blocking, RPC server threads use the same input arguments, including the
- * RPC responses counter field.
- *********************************************************************************************
- * @ pid         : target process identifier.
- * @ action_type : BLOCK_ALL_THREADS / UNBLOCK_ALL_THREADS / DELETE_ALL_THREADS
- ********************************************************************************************/
-void process_sigaction( pid_t       pid,
-                        uint32_t    action_type );
-
-/*********************************************************************************************
- * This function marks for delete all threads for a given <process> in the local cluster.
- * It scan the list of local thread, and sets the THREAD_FLAG_REQ_DELETE bit for all
- * threads, BUT the main thread (thread 0 in owner cluster), and the client thread
- * identified by the <client_xp> argument. 
- * The actual delete will be done by the scheduler at the next scheduling point.
- *********************************************************************************************
+/********************************************************************************************* 
+ * This function kills an user process in a given cluster.
+ * It can be directly called in the reference cluster, or it can be called through the
+ * PROCESS_KILL RPC.
+ * - In a first loop, it set the THREAD_SIG_KILL signal to all threads of process.
+ * - In a second loop, it wait, for each thread the reset of the THREAD_SIG_KILL signal
+ *   by the scheduler, and completes the thread descriptor destruction. 
+ ********************************************************************************************* 
  * @ process     : pointer on the process descriptor.
- * @ client_xp   : extended pointer on the client thread that should not be marked.
- ********************************************************************************************/
-void process_delete_threads( process_t * process,
-                             xptr_t      client_xp );
-
-/*********************************************************************************************
- * This function blocks all threads for a given <process> in the local cluster. 
- * It scan the list of local thread, and sets the THREAD_BLOCKED_GLOBAL bit for all threads.
- * It request the relevant schedulers to acknowledge the blocking, using IPI if required, 
- * when the target thread is running on another core than the calling thread.
- * It returns only when all threads in cluster, including the caller are actually blocked.
- * The threads are not detached from the scheduler, and not detached from the local process.
- *********************************************************************************************
- * @ process     : pointer on the target process descriptor.
- ********************************************************************************************/
-void process_block_threads( process_t * process );
-
-/*********************************************************************************************
- * This function unblocks all threads of a given user process in a given cluster.
- *********************************************************************************************
- * @ process     : pointer on the process descriptor.
- ********************************************************************************************/
-void process_unblock_threads( process_t * process );
-
-/*********************************************************************************************
+ ********************************************************************************************/
+void process_kill( process_t * process );
+
+/********************************************************************************************* 
  * This function returns a pointer on the local copy of a process identified by its PID.
- * If this local copy does not exist yet, it is dynamically created, from the reference
+ * If this local copy does not exist yet, it is dynamically created, from the reference 
  * process descriptor, registered in the global copies_list, and registered in the local_list.
- * This function is used by the thread_user_create() function.
- *********************************************************************************************
+ * This function is used by both thread_user_create() and thread_user_copy() functions.
+ ********************************************************************************************* 
  * @ pid     : searched process identifier.
  * @ returns pointer on the local process descriptor if success / returns NULL if failure.
